/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
/*
 * Generated by Gas3 v2.2.0 (Granite Data Services).
 *
 * NOTE: this file is only generated if it does not exist. You may safely put
 * your custom code here.
 */

package org.ow2.orchestra.designer.bpmn.model {
  import org.ow2.orchestra.designer.bpmn.model.operations.InterfaceModel;
  import org.ow2.orchestra.designer.bpmn.model.operations.OperationModel;
  import org.ow2.orchestra.designer.bpmn.model.utils.IDUtil;

  [Bindable]
  [RemoteClass(alias="org.ow2.orchestra.designer.bpmn.model.EventModel")]
  public class EventModel extends EventModelBase {
    public function EventModel() {
      super();
      this.eventType = EventType.NONE;
      // Default timer to 5 sec
      this.timerDuration = "PT5S";
    }

    public override function set name(value:String):void {
      var oldName:String = name;
      super.name = value;
      if (variableName == null || variableName == oldName + "Var") {
        variableName = value + "Var";
      }
      if (expression == null || expression == "getDataObject(\"" + oldName + "Var\")") {
        this.expression = "getDataObject(\"" + name + "Var\")";
      }
      if (eventType == EventType.RECEIVE_MESSAGE) {
        if (operation.interfaceModel.name == oldName + "Interface") {
          interfaceName = value + "Interface";
        }
        if (operation.name == oldName + "Operation") {
          operationName = value + "Operation";
        }
      }
    }

    public override function set eventType(value:EventType):void {
      if (value != eventType) {
        super.eventType = value;
        if (value == EventType.RECEIVE_MESSAGE) {
          // reset default interface (sets default operation name)
          setDefaultOperation();
        } else {
          operation = null;
        }
      }
    }


    public override function set operation(value:OperationModel):void {
      if (operation != null) {
        var index:int = operation.receiveElements.getItemIndex(this);
        if (index >= 0) {
          operation.receiveElements.removeItemAt(index);
        }
        index = operation.sendElements.getItemIndex(this);
        if (index >= 0) {
          operation.sendElements.removeItemAt(index);
        }
      }
      super.operation = value;
      if (value != null) {
        if (eventType == EventType.RECEIVE_MESSAGE) {
          value.receiveElements.addItem(this);
        } else if (eventType == EventType.SEND_MESSAGE) {
          value.sendElements.addItem(this);
        }
      }
    }

    public function set operationName(operationName:String):void {
      var iface:InterfaceModel = operation.interfaceModel;
      var newOperation:OperationModel = iface.operations.get(operationName);
      if (newOperation == null) {
        newOperation = new OperationModel();
        newOperation.id = IDUtil.generateId();
        newOperation.name = operationName;
        newOperation.interfaceModel = iface;
        iface.operations.put(operationName, newOperation);
      }
      this.operation = newOperation;
    }

    public function set interfaceName(interfaceName:String):void {
      var operationName:String;
      if (operation != null) {
        operationName = operation.name;
      } else {
        operationName = interfaceName + "DefaultOperation";
      }
      var iface:InterfaceModel = processModel.interfaces.get(interfaceName);
      if (iface == null) {
        iface = new InterfaceModel();
        iface.id = IDUtil.generateId();
        iface.name = interfaceName;
        iface.poolModel = processModel;
        processModel.interfaces.put(interfaceName, iface);
      }
      var newOperation:OperationModel = iface.operations.get(operationName);
      if (newOperation == null) {
        newOperation = new OperationModel();
        newOperation.id = IDUtil.generateId();
        newOperation.name = operationName;
        newOperation.interfaceModel = iface;
        iface.operations.put(operationName, newOperation);
      }
      this.operation = newOperation;
    }

    private function setDefaultOperation():void {
      interfaceName = name + "Interface";
      operationName = name + "Operation";
    }
  }
}
