/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
/*
 * Generated by Gas3 v2.2.0 (Granite Data Services).
 *
 * NOTE: this file is only generated if it does not exist. You may safely put
 * your custom code here.
 */

package org.ow2.orchestra.designer.bpmn.model {
  import flash.events.Event;

  import mx.binding.utils.ChangeWatcher;
  import mx.events.CollectionEvent;

  [Bindable]
  [RemoteClass(alias="org.ow2.orchestra.designer.bpmn.model.SequenceFlowModel")]
  public class SequenceFlowModel extends SequenceFlowModelBase {

    private var changeWatcher:ChangeWatcher;

    public function SequenceFlowModel() {
      super();
      changeWatcher = ChangeWatcher.watch(sourceElement, "gatewayType", checkExclusiveGateway);
    }

    public override function onDeserializationComplete():void {
      changeWatcher = ChangeWatcher.watch(sourceElement, "gatewayType", checkExclusiveGateway);
      sourceElement.outgoingSequenceFlows.addEventListener(CollectionEvent.COLLECTION_CHANGE, checkExclusiveGateway);
    }



    public override function set sourceElement(newSource:AbstractElementWithPosition):void {
      // Change sequence flow source
      // Remove from old source outgoing sequence flows list
      var oldSource:AbstractElementWithPosition = this.sourceElement;
      if (oldSource != null) {
        changeWatcher.unwatch();
        oldSource.outgoingSequenceFlows.removeEventListener(CollectionEvent.COLLECTION_CHANGE, checkExclusiveGateway);
        var index:int = oldSource.outgoingSequenceFlows.getItemIndex(this);
        if (index != -1) {
          oldSource.outgoingSequenceFlows.removeItemAt(index);
        }
      }
      // Add to new source outgoing sequence flows list
      if (newSource != null) {
        newSource.outgoingSequenceFlows.addItem(this);
        newSource.outgoingSequenceFlows.addEventListener(CollectionEvent.COLLECTION_CHANGE, checkExclusiveGateway);
        changeWatcher.reset(newSource);
      }
      // update sourceElement
      super.sourceElement = newSource;
    }

    public override function set targetElement(newTarget:AbstractElementWithPosition):void {
      // Change sequence flow target
      // Remove from old target incoming sequence flows list
      var oldTarget:AbstractElementWithPosition = this.targetElement;
      if (oldTarget != null) {
        var index:int = oldTarget.incomingSequenceFlows.getItemIndex(this);
        if (index != -1) {
          oldTarget.incomingSequenceFlows.removeItemAt(index);
        }
      }
      // Add to new target incoming sequence flows list
      if (newTarget != null) {
        newTarget.incomingSequenceFlows.addItem(this);
      }
      // update target Element
      super.targetElement = newTarget;
    }


    /**
     * If sourceElement is not an exclusive gateway, condition should be set to null
     * If sourceElement is an exclusive gateway, determine if this sequenceFlow si the default sequenceFlow.
     */
    private function checkExclusiveGateway(event:Event = null):void {
      if ((sourceElement is GatewayModel) && (sourceElement as GatewayModel).gatewayType == GatewayType.EXCLUSIVE) {
        if (condition == null) {
          condition = "";
        }
        if (sourceElement.outgoingSequenceFlows.length > 1 && condition == "") {
          var isDef:Boolean = true;
          for each(var seq:SequenceFlowModel in sourceElement.outgoingSequenceFlows) {
            if (seq != this && seq.condition == "") {
              isDef = false;
            }
          }
          this.isDefault = isDef;
        } else {
          this.isDefault = false;
        }
      } else {
        this.condition = null;
        this.isDefault = false;
      }
    }
  }

}
