/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
/*
 * Generated by Gas3 v2.2.0 (Granite Data Services).
 *
 * NOTE: this file is only generated if it does not exist. You may safely put
 * your custom code here.
 */

package org.ow2.orchestra.designer.bpmn.model.operations {
  import flash.utils.IDataInput;

  import mx.events.CollectionEvent;

  import org.ow2.orchestra.designer.bpmn.model.EventModel;

  [Bindable]
  [RemoteClass(alias="org.ow2.orchestra.designer.bpmn.model.operations.OperationModel")]
  public class OperationModel extends OperationModelBase {
    public function OperationModel() {
      super();
      this.inMessageType = "{http://www.w3.org/2001/XMLSchema}string";
      this.receiveElements.addEventListener(CollectionEvent.COLLECTION_CHANGE, onReceiveElementsChange);
      this.sendElements.addEventListener(CollectionEvent.COLLECTION_CHANGE, onSendElementsChange);
    }

// Add event listener for receive elements changes
    public override function readExternal(input:IDataInput):void {
      super.readExternal(input);
      this.receiveElements.addEventListener(CollectionEvent.COLLECTION_CHANGE, onReceiveElementsChange);
      this.sendElements.addEventListener(CollectionEvent.COLLECTION_CHANGE, onSendElementsChange);
    }

    private function onReceiveElementsChange(event:CollectionEvent):void {
      if (this.receiveElements.length == 0) {
        // No more receive elements for this operation, delete operation
        if (this.interfaceModel != null) {
          this.interfaceModel.operations.remove(this.name);
        }
        for each (var sendElement:Object in this.sendElements) {
          if (sendElement is EventModel) {
            (sendElement as EventModel).operation = null;
          }
        }
      }
    }

    private function onSendElementsChange(event:CollectionEvent):void {
      if (this.sendElements.length == 0) {
        // No more send elements for this operation, delete output
        this.outMessageType = null;
      } else if (this.outMessageType == null) {
        // set default output type to xsd:string
        this.outMessageType = "{http://www.w3.org/2001/XMLSchema}string";
      }
    }
  }
}
